// $Id: MSXDiskRomPatch.hh,v 1.28 2002/08/16 23:13:21 mthuurne Exp $

#ifndef __MSXDISKROMPATCH_HH__
#define __MSXDISKROMPATCH_HH__

#include <string>

#include "MSXRomPatchInterface.hh"

// forward declarations
class DiskImageManager;


class MSXDiskRomPatch : public MSXRomPatchInterface
{
	public:
		MSXDiskRomPatch();
		virtual ~MSXDiskRomPatch();

		virtual void patch(CPU::CPURegs& regs);

	private:
		/**
		 * read/write sectors
		 */
		void PHYDIO(CPU::CPURegs& regs);
		
		/**
		 * check disk
		 */
		void DSKCHG(CPU::CPURegs& regs);

		/**
		 * get disk format
		 */
		void GETDPB(CPU::CPURegs& regs);

		/**
		 * format a disk
		 */
		void DSKFMT(CPU::CPURegs& regs);
		static const byte bootSectorData[]; // size is 196

		/**
		 * stop drives
		 */
		void DRVOFF(CPU::CPURegs& regs);

		DiskImageManager* diskImageManager;

		static const int LAST_DRIVE = 2;
		std::string name[LAST_DRIVE];
};

#endif // __MSXDISKROMPATCH_HH__
