// $Id: MSXMemoryMapper.hh,v 1.19 2002/08/16 18:36:49 m9710797 Exp $

#ifndef __MSXMEMORYMAPPER_HH__
#define __MSXMEMORYMAPPER_HH__

#include "MSXMemDevice.hh"

// forward declaration;
class MSXMapperIO;


class MSXMemoryMapper : public MSXMemDevice
{
	public:
		/**
		 * Constructor
		 */
		MSXMemoryMapper(MSXConfig::Device *config, const EmuTime &time);

		/**
		 * Destructor
		 */
		virtual ~MSXMemoryMapper();
		
		virtual byte readMem(word address, const EmuTime &time);
		virtual void writeMem(word address, byte value, const EmuTime &time);
		virtual byte* getReadCacheLine(word start);
		virtual byte* getWriteCacheLine(word start);
		
		virtual void reset(const EmuTime &time);
	
	private:
		/** Converts a Z80 address to a RAM address.
		  * @param address Index in Z80 address space.
		  * @return Index in RAM address space.
		  */
		inline int calcAddress(word address);

		byte *buffer;
		MSXMapperIO* mapperIO;
		int nbBlocks;
		bool slowDrainOnReset;
};

#endif //__MSXMEMORYMAPPER_HH__
