// $Id: MSXTurboRLeds.hh,v 1.1 2002/09/01 16:07:39 m9710797 Exp $

/*
 * This class implements the 2 Turbo-R specific LEDS:
 *  
 * Bit 0 of IO-port 0xA7 turns the PAUSE led ON (1) or OFF (0) 
 * Bit 7                           TURBO
 * This port can only be written to.
 */

#ifndef __TURBORLEDS_HH__
#define __TURBORLEDS_HH__

#include "MSXIODevice.hh"


class MSXTurboRLeds : public MSXIODevice
{
	public:
		MSXTurboRLeds(MSXConfig::Device *config, const EmuTime &time);
		virtual ~MSXTurboRLeds();
		
		virtual void reset(const EmuTime &time);
		virtual void writeIO(byte port, byte value, const EmuTime &time);
};

#endif
