// $Id: FDCBackEnd.cc,v 1.6 2002/08/14 12:16:33 m9710797 Exp $

#include "FDCBackEnd.hh"


FDCBackEnd::FDCBackEnd()
{
	nbSides = 0;
}

void FDCBackEnd::getTrackHeader(byte phystrack, byte track, byte side, byte* buf)
{
	PRT_DEBUG("FDCBackEnd::getTrackHeader [unimplemented]");
}
void FDCBackEnd::getSectorHeader(byte phystrack, byte track, byte sector, byte side, byte* buf)
{
	PRT_DEBUG("FDCBackEnd::getSectorHeader [unimplemented]");
}

void FDCBackEnd::readSector(byte* buf, int logSector)
{
	byte track, side, sector;
	logToPhys(logSector, track, side, sector);
	read(track, track, sector, side, 512, buf);
}

void FDCBackEnd::writeSector(const byte* buf, int logSector)
{
	byte track, side, sector;
	logToPhys(logSector, track, side, sector);
	write(track, track, sector, side, 512, buf);
}


int FDCBackEnd::physToLog(byte track, byte side, byte sector)
{
	if ((track == 0) && (side == 0) && (sector == 1))	// bootsector
		return 0;
	if (!nbSides) readBootSector();
	return sectorsPerTrack * (side + nbSides * track) + (sector - 1);
}

void FDCBackEnd::logToPhys(int log, byte &track, byte &side, byte &sector)
{
	if (!nbSides) readBootSector();
	track = log / (nbSides * sectorsPerTrack);
	side = (log / sectorsPerTrack) % nbSides;
	sector = (log % sectorsPerTrack) + 1;
}

void FDCBackEnd::readBootSector()
{
	byte buf[512];
	read(0, 0, 1, 0, 512, buf);
	sectorsPerTrack = buf[0x18] + 256 * buf[0x19];
	nbSides         = buf[0x1A] + 256 * buf[0x1B];
	PRT_DEBUG("FDCBackEnd sectorsPerTrack " << sectorsPerTrack);
	PRT_DEBUG("FDCBackEnd nbSides         " << nbSides);
}

